package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.HT;
import com.sa.ibiz.demo.demo.service.HTService;
import com.sa.ibiz.demo.demo.service.dto.HTSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/ht")
public class HTResource
{
	@Autowired
	private HTService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<HT> get(@Validated @PathVariable String id){
		HT data=new HT();
		data.setHtid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("合同[get]操作发生错误","HT",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<HT> remove(@Validated @RequestBody HT data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("合同[remove]操作发生错误","HT",data.getHtid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getXminfo")
	public ResponseEntity<HT> getXminfo(@Validated @RequestBody HT data){
		service.getXminfo(data);
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<HT> update(@Validated @RequestBody HT data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("合同[update]操作发生错误","HT",data.getHtid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<HT> create(@Validated @RequestBody HT data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("合同[create]操作发生错误","HT",data.getHtid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<HT> checkKey(@Validated @RequestBody HT data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("合同[checkKey]操作发生错误","HT",data.getHtid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<HT> getDraft(@Validated @RequestBody HT data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("合同[getDraft]操作发生错误","HT","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<HT>> searchDefaultPage(@Validated @RequestBody HTSearchFilter filter){
		Page<HT> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<HT>> listDefault(@Validated @RequestBody HTSearchFilter filter){
		List<HT> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
